--- mkdir.c	Sun Jun 08 02:10:42 1997
+++ new/mkdir.c	Wed Aug 06 23:18:46 1997
@@ -1,16 +1,26 @@
 /*
  * mkdir.c --- make a directory in the filesystem
  * 
- * Copyright (C) 1994 Theodore Ts'o.  This file may be redistributed
- * under the terms of the GNU Public License.
+ * Copyright (C) 1994, 1995 Theodore Ts'o.
+ *
+ * %Begin-Header%
+ * This file may be redistributed under the terms of the GNU Public
+ * License.
+ * %End-Header%
  */
 
 #include <stdio.h>
 #include <string.h>
+#include <unistd.h>
 #include <stdlib.h>
-#include <errno.h>
-#include <linux/types.h>
+#include <fcntl.h>
 #include <time.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#if HAVE_ERRNO_H
+#include <errno.h>
+#endif
+
 #include <linux/ext2_fs.h>
 
 #include "ext2fs.h"
@@ -31,12 +41,9 @@
 	/*
 	 * Allocate an inode, if necessary
 	 */
-
-// from linux kernel : include/linux/stat.h
-#define S_IFDIR  0040000
-
 	if (!ino) {
-		retval = ext2fs_new_inode(fs, parent, S_IFDIR | 0755, 0, &ino);
+		retval = ext2fs_new_inode(fs, parent, LINUX_S_IFDIR | 0755,
+					  0, &ino);
 		if (retval)
 			goto cleanup;
 	}
@@ -59,7 +66,7 @@
 	 * Create the inode structure....
 	 */
 	memset(&inode, 0, sizeof(struct ext2_inode));
-	inode.i_mode = S_IFDIR | 0755;
+	inode.i_mode = LINUX_S_IFDIR | 0755;
 	inode.i_uid = inode.i_gid = 0;
 	inode.i_blocks = fs->blocksize / 512;
 	inode.i_block[0] = blk;
@@ -70,7 +77,7 @@
 	/*
 	 * Write out the inode and inode data block
 	 */
-	retval = io_channel_write_blk(fs->io, blk, 1, block);
+	retval = ext2fs_write_dir_block(fs, blk, block);
 	if (retval)
 		goto cleanup;
 	retval = ext2fs_write_inode(fs, ino, &inode); 
